################################################################################

# IMPORT-DATA stats scan-*.txt random-*.txt

# SQL ALTER TABLE stats ADD COLUMN exp VARCHAR
# SQL UPDATE stats SET exp = 'scan'
# SQL UPDATE stats SET exp = 'random' WHERE num_blocks_in_span IS NOT NULL

# SQL ALTER TABLE stats ADD COLUMN hostx INT4

# i10pc130: WDC WD1000DHTZ-04N21V1 Velociraptor 1TB, (2012)
# SQL UPDATE stats SET host='HDD-2012', hostx=1 WHERE host='i10pc130'

# i10pc129: Samsung SSD 840 EVO 1TB, 2013
# SQL UPDATE stats SET host='SSD-2013', hostx=2 WHERE host='i10pc129'

# i10pc133: Samsung 960 Pro NVMe 512GB, October 2016
# SQL UPDATE stats SET host='NVMe-2016', hostx=3 WHERE host='i10pc133'

# SQL UPDATE stats SET batch_size = batch_size / block_size WHERE exp='random'

#set terminal pdf size 28cm,18cm linewidth 2.0 noenhanced
set terminal pdf size 20cm,15cm linewidth 2.0 noenhanced font ",16"
set output "storage-performance.pdf"

set pointsize 0.8
set style increment user

set grid xtics ytics

set key bottom right reverse Left font ",12"

set xlabel 'block size (log_2(B))'
set ylabel 'bandwidth (MB/s)'

set style line 1 lt 1 dashtype 1 lc 1
set style line 2 lt 2 dashtype 1 lc rgb "#00cc00"
set style line 3 lt 3 dashtype 1 lc 3
set style line 4 lt 4 dashtype 1 lc 4
set style line 5 lt 5 dashtype 1 lc 5
set style line 6 lt 6 dashtype 1 lc rgb "#f0b000"
set style line 7 lt 7 dashtype 1 lc 7
set style line 8 lt 8 dashtype 1 lc rgb "#aa55ff"
set style line 9 lt 1 dashtype 2 lc 1
set style line 10 lt 2 dashtype 2 lc rgb "#00cc00"
set style line 11 lt 3 dashtype 2 lc 3
set style line 12 lt 4 dashtype 2 lc 4
set style line 13 lt 5 dashtype 2 lc 5
set style line 14 lt 6 dashtype 2 lc rgb "#f0b000"
set style line 15 lt 7 dashtype 2 lc 7
set style line 16 lt 8 dashtype 2 lc rgb "#aa55ff"

set title 'Scan: Sequential Disk Access Speed - WD1000DHTZ Velociraptor 10000rpm 1TB (HDD-2012) '

## MULTIPLOT(op,batch_size)
## SELECT LOG(2, block_size) AS x,
## (read_size + write_size) / (read_time + write_time) / 1024 / 1024 AS y, MULTIPLOT
## FROM stats
## WHERE exp='scan' AND op='r' AND host='HDD-2012'
## ORDER BY MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 0 title "op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 1 title "op=r,batch_size=2" with linespoints, \
    'storage-performance-data.txt' index 2 title "op=r,batch_size=4" with linespoints, \
    'storage-performance-data.txt' index 3 title "op=r,batch_size=8" with linespoints, \
    'storage-performance-data.txt' index 4 title "op=r,batch_size=16" with linespoints, \
    'storage-performance-data.txt' index 5 title "op=r,batch_size=32" with linespoints, \
    'storage-performance-data.txt' index 6 title "op=r,batch_size=64" with linespoints, \
    'storage-performance-data.txt' index 7 title "op=r,batch_size=128" with linespoints

## MULTIPLOT(op,batch_size)
## SELECT LOG(2, block_size) AS x,
## (read_size + write_size) / (read_time + write_time) / 1024 / 1024 AS y, MULTIPLOT
## FROM stats
## WHERE exp='scan' AND host='HDD-2012'
## ORDER BY MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 8 title "op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 9 title "op=r,batch_size=2" with linespoints, \
    'storage-performance-data.txt' index 10 title "op=r,batch_size=4" with linespoints, \
    'storage-performance-data.txt' index 11 title "op=r,batch_size=8" with linespoints, \
    'storage-performance-data.txt' index 12 title "op=r,batch_size=16" with linespoints, \
    'storage-performance-data.txt' index 13 title "op=r,batch_size=32" with linespoints, \
    'storage-performance-data.txt' index 14 title "op=r,batch_size=64" with linespoints, \
    'storage-performance-data.txt' index 15 title "op=r,batch_size=128" with linespoints, \
    'storage-performance-data.txt' index 16 title "op=w,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 17 title "op=w,batch_size=2" with linespoints, \
    'storage-performance-data.txt' index 18 title "op=w,batch_size=4" with linespoints, \
    'storage-performance-data.txt' index 19 title "op=w,batch_size=8" with linespoints, \
    'storage-performance-data.txt' index 20 title "op=w,batch_size=16" with linespoints, \
    'storage-performance-data.txt' index 21 title "op=w,batch_size=32" with linespoints, \
    'storage-performance-data.txt' index 22 title "op=w,batch_size=64" with linespoints, \
    'storage-performance-data.txt' index 23 title "op=w,batch_size=128" with linespoints

set title 'Scan: Sequential Disk Access Speed - Samsung SSD 840 EVO 1TB (SSD-2013)'

## MULTIPLOT(op,batch_size)
## SELECT LOG(2, block_size) AS x, read_size / read_time / 1024 / 1024 AS y, MULTIPLOT
## FROM stats
## WHERE exp='scan' AND op='r' AND host='SSD-2013'
## ORDER BY MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 24 title "op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 25 title "op=r,batch_size=2" with linespoints, \
    'storage-performance-data.txt' index 26 title "op=r,batch_size=4" with linespoints, \
    'storage-performance-data.txt' index 27 title "op=r,batch_size=8" with linespoints, \
    'storage-performance-data.txt' index 28 title "op=r,batch_size=16" with linespoints, \
    'storage-performance-data.txt' index 29 title "op=r,batch_size=32" with linespoints, \
    'storage-performance-data.txt' index 30 title "op=r,batch_size=64" with linespoints, \
    'storage-performance-data.txt' index 31 title "op=r,batch_size=128" with linespoints

set title 'Scan: Sequential Disk Access Speed - Samsung SSD 840 EVO 1TB (SSD-2013)'

## MULTIPLOT(op,batch_size)
## SELECT LOG(2, block_size) AS x,
## (read_size + write_size) / (read_time + write_time) / 1024 / 1024 AS y, MULTIPLOT
## FROM stats
## WHERE exp='scan' AND host='SSD-2013'
## ORDER BY MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 32 title "op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 33 title "op=r,batch_size=2" with linespoints, \
    'storage-performance-data.txt' index 34 title "op=r,batch_size=4" with linespoints, \
    'storage-performance-data.txt' index 35 title "op=r,batch_size=8" with linespoints, \
    'storage-performance-data.txt' index 36 title "op=r,batch_size=16" with linespoints, \
    'storage-performance-data.txt' index 37 title "op=r,batch_size=32" with linespoints, \
    'storage-performance-data.txt' index 38 title "op=r,batch_size=64" with linespoints, \
    'storage-performance-data.txt' index 39 title "op=r,batch_size=128" with linespoints, \
    'storage-performance-data.txt' index 40 title "op=w,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 41 title "op=w,batch_size=2" with linespoints, \
    'storage-performance-data.txt' index 42 title "op=w,batch_size=4" with linespoints, \
    'storage-performance-data.txt' index 43 title "op=w,batch_size=8" with linespoints, \
    'storage-performance-data.txt' index 44 title "op=w,batch_size=16" with linespoints, \
    'storage-performance-data.txt' index 45 title "op=w,batch_size=32" with linespoints, \
    'storage-performance-data.txt' index 46 title "op=w,batch_size=64" with linespoints, \
    'storage-performance-data.txt' index 47 title "op=w,batch_size=128" with linespoints

set title 'Scan: Sequential Disk Access Speed - Samsung 960 Pro NVMe 512GB (NVMe-2016)'

## MULTIPLOT(op,batch_size)
## SELECT LOG(2, block_size) AS x,
## (read_size + write_size) / (read_time + write_time) / 1024 / 1024 AS y, MULTIPLOT
## FROM stats
## WHERE exp='scan' AND op='r' AND host='NVMe-2016'
## ORDER BY MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 48 title "op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 49 title "op=r,batch_size=2" with linespoints, \
    'storage-performance-data.txt' index 50 title "op=r,batch_size=4" with linespoints, \
    'storage-performance-data.txt' index 51 title "op=r,batch_size=8" with linespoints, \
    'storage-performance-data.txt' index 52 title "op=r,batch_size=16" with linespoints, \
    'storage-performance-data.txt' index 53 title "op=r,batch_size=32" with linespoints, \
    'storage-performance-data.txt' index 54 title "op=r,batch_size=64" with linespoints, \
    'storage-performance-data.txt' index 55 title "op=r,batch_size=128" with linespoints

## MULTIPLOT(op,batch_size)
## SELECT LOG(2, block_size) AS x,
## (read_size + write_size) / (read_time + write_time) / 1024 / 1024 AS y, MULTIPLOT
## FROM stats
## WHERE exp='scan' AND host='NVMe-2016'
## ORDER BY MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 56 title "op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 57 title "op=r,batch_size=2" with linespoints, \
    'storage-performance-data.txt' index 58 title "op=r,batch_size=4" with linespoints, \
    'storage-performance-data.txt' index 59 title "op=r,batch_size=8" with linespoints, \
    'storage-performance-data.txt' index 60 title "op=r,batch_size=16" with linespoints, \
    'storage-performance-data.txt' index 61 title "op=r,batch_size=32" with linespoints, \
    'storage-performance-data.txt' index 62 title "op=r,batch_size=64" with linespoints, \
    'storage-performance-data.txt' index 63 title "op=r,batch_size=128" with linespoints, \
    'storage-performance-data.txt' index 64 title "op=w,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 65 title "op=w,batch_size=2" with linespoints, \
    'storage-performance-data.txt' index 66 title "op=w,batch_size=4" with linespoints, \
    'storage-performance-data.txt' index 67 title "op=w,batch_size=8" with linespoints, \
    'storage-performance-data.txt' index 68 title "op=w,batch_size=16" with linespoints, \
    'storage-performance-data.txt' index 69 title "op=w,batch_size=32" with linespoints, \
    'storage-performance-data.txt' index 70 title "op=w,batch_size=64" with linespoints, \
    'storage-performance-data.txt' index 71 title "op=w,batch_size=128" with linespoints

set title 'Scan: Sequential Disk Access Speed - Batch Size 1 and 128'

set key top left font ",12"

set style line 1 dashtype 1 lc 1 lt 1
set style line 2 dashtype 2 lc 1 lt 2
set style line 3 dashtype 3 lc 1 lt 3
set style line 4 dashtype 4 lc 1 lt 4
set style line 5 dashtype 1 lc rgb "#00cc00" lt 1
set style line 6 dashtype 2 lc rgb "#00cc00" lt 2
set style line 7 dashtype 3 lc rgb "#00cc00" lt 3
set style line 8 dashtype 4 lc rgb "#00cc00" lt 4
set style line 9 dashtype 1 lc 3 lt 1
set style line 10 dashtype 2 lc 3 lt 2
set style line 11 dashtype 3 lc 3 lt 3
set style line 12 dashtype 4 lc 3 lt 4

## MULTIPLOT(host,op,batch_size)
## SELECT LOG(2, block_size) AS x,
## (read_size + write_size) / (read_time + write_time) / 1024 / 1024 AS y, MULTIPLOT
## FROM stats
## WHERE exp='scan' AND batch_size IN (1,128)
## ORDER BY hostx,MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 72 title "host=HDD-2012,op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 73 title "host=HDD-2012,op=r,batch_size=128" with linespoints, \
    'storage-performance-data.txt' index 74 title "host=HDD-2012,op=w,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 75 title "host=HDD-2012,op=w,batch_size=128" with linespoints, \
    'storage-performance-data.txt' index 76 title "host=SSD-2013,op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 77 title "host=SSD-2013,op=r,batch_size=128" with linespoints, \
    'storage-performance-data.txt' index 78 title "host=SSD-2013,op=w,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 79 title "host=SSD-2013,op=w,batch_size=128" with linespoints, \
    'storage-performance-data.txt' index 80 title "host=NVMe-2016,op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 81 title "host=NVMe-2016,op=r,batch_size=128" with linespoints, \
    'storage-performance-data.txt' index 82 title "host=NVMe-2016,op=w,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 83 title "host=NVMe-2016,op=w,batch_size=128" with linespoints

################################################################################

reset

set pointsize 0.8
set style increment user

set grid xtics ytics

set key bottom right reverse Left font ",12"

################################################################################

set xlabel 'block size (log_2(B))'
set ylabel 'latency per block (ms)'

unset yrange
set logscale y

set style line 1 lt 1 lc 1 dashtype 1
set style line 2 lt 2 lc 1 dashtype 2
set style line 3 lt 1 lc rgb "#00cc00" dashtype 1
set style line 4 lt 2 lc rgb "#00cc00" dashtype 2
set style line 5 lt 1 lc 3 dashtype 1
set style line 6 lt 2 lc 3 dashtype 2

set title 'Random: Batch Random Block Access Latency - Batch Size 1'

## MULTIPLOT(host,op,batch_size)
## SELECT LOG(2, block_size) AS x,
## (1 / (read_blocks_per_sec + write_blocks_per_sec) * 1000) AS y, MULTIPLOT
## FROM stats
## WHERE exp='random' AND op IN ('r','w') AND batch_size IN (1)
## ORDER BY hostx,MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 84 title "host=HDD-2012,op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 85 title "host=HDD-2012,op=w,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 86 title "host=SSD-2013,op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 87 title "host=SSD-2013,op=w,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 88 title "host=NVMe-2016,op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 89 title "host=NVMe-2016,op=w,batch_size=1" with linespoints

set title 'Random: Batch Random Block Access Latency - Batch Size 1024'
set ylabel 'speedup of batch access'

## MULTIPLOT(host,op,batch_size)
## SELECT LOG(2, block_size) AS x,
## (1 / (read_blocks_per_sec + write_blocks_per_sec) * 1000) AS y, MULTIPLOT
## FROM stats
## WHERE exp='random' AND op IN ('r','w') AND batch_size IN (1024)
## ORDER BY hostx,MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 90 title "host=HDD-2012,op=r,batch_size=1024" with linespoints, \
    'storage-performance-data.txt' index 91 title "host=HDD-2012,op=w,batch_size=1024" with linespoints, \
    'storage-performance-data.txt' index 92 title "host=SSD-2013,op=r,batch_size=1024" with linespoints, \
    'storage-performance-data.txt' index 93 title "host=SSD-2013,op=w,batch_size=1024" with linespoints, \
    'storage-performance-data.txt' index 94 title "host=NVMe-2016,op=r,batch_size=1024" with linespoints, \
    'storage-performance-data.txt' index 95 title "host=NVMe-2016,op=w,batch_size=1024" with linespoints

set title 'Random: Batch Random Block Access Latency - Speedup of Batch Size 1024 over 1'

unset yrange
unset logscale y

## MULTIPLOT(host,op)
## SELECT LOG(2, block_size) AS x,
## (read_blocks_per_sec + write_blocks_per_sec) /
## (SELECT (read_blocks_per_sec + write_blocks_per_sec)
##    FROM stats s2 WHERE s2.host = s.host AND s2.op = s.op AND s2.exp = s.exp
##     AND s2.op = s.op AND s2.block_size = s.block_size AND s2.batch_size = 1) AS y, MULTIPLOT
## FROM stats s
## WHERE exp='random' AND op IN ('r','w') AND batch_size = 1024
## ORDER BY hostx,MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 96 title "host=HDD-2012,op=r" with linespoints, \
    'storage-performance-data.txt' index 97 title "host=HDD-2012,op=w" with linespoints, \
    'storage-performance-data.txt' index 98 title "host=SSD-2013,op=r" with linespoints, \
    'storage-performance-data.txt' index 99 title "host=SSD-2013,op=w" with linespoints, \
    'storage-performance-data.txt' index 100 title "host=NVMe-2016,op=r" with linespoints, \
    'storage-performance-data.txt' index 101 title "host=NVMe-2016,op=w" with linespoints

set title 'Random: Batch Random Block Access Latency - Batch Speedup for 4 KiB Blocks'
set key right center
set xlabel 'batch size (k)'

set logscale x

## MULTIPLOT(host,op)
## SELECT batch_size AS x,
## (read_blocks_per_sec + write_blocks_per_sec) /
## (SELECT (read_blocks_per_sec + write_blocks_per_sec)
##    FROM stats s2 WHERE s2.host = s.host AND s2.op = s.op AND s2.exp = s.exp
##     AND s2.op = s.op AND s2.block_size = s.block_size AND s2.batch_size = 1) AS y, MULTIPLOT
## FROM stats s
## WHERE exp='random' AND op IN ('r','w') AND block_size = 4096
## ORDER BY hostx,MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 102 title "host=HDD-2012,op=r" with linespoints, \
    'storage-performance-data.txt' index 103 title "host=HDD-2012,op=w" with linespoints, \
    'storage-performance-data.txt' index 104 title "host=SSD-2013,op=r" with linespoints, \
    'storage-performance-data.txt' index 105 title "host=SSD-2013,op=w" with linespoints, \
    'storage-performance-data.txt' index 106 title "host=NVMe-2016,op=r" with linespoints, \
    'storage-performance-data.txt' index 107 title "host=NVMe-2016,op=w" with linespoints

################################################################################

reset

set pointsize 0.8
set style increment user

set grid xtics ytics

set key bottom right reverse Left font ",12"

################################################################################

set xlabel 'block size (log_2(B))'
#set xlabel 'batch size (log_2(k))'
#set ylabel 'time per block batch (ms)'
set ylabel 'bandwidth (MiB/s)'

set title 'Random Read: Batch Random Block Access Bandwidth - WD1000DHTZ Velociraptor 10000rpm 1TB (HDD-2012)'

#set logscale y

## MULTIPLOT(op,batch_size)
## SELECT LOG(2, block_size) AS x,
## (read_bytes_per_sec + write_bytes_per_sec) / 1024 / 1024 AS y, MULTIPLOT
## FROM stats
## WHERE exp='random' AND op IN ('r') AND host='HDD-2012'
## ORDER BY MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 108 title "op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 109 title "op=r,batch_size=2" with linespoints, \
    'storage-performance-data.txt' index 110 title "op=r,batch_size=4" with linespoints, \
    'storage-performance-data.txt' index 111 title "op=r,batch_size=8" with linespoints, \
    'storage-performance-data.txt' index 112 title "op=r,batch_size=16" with linespoints, \
    'storage-performance-data.txt' index 113 title "op=r,batch_size=32" with linespoints, \
    'storage-performance-data.txt' index 114 title "op=r,batch_size=64" with linespoints, \
    'storage-performance-data.txt' index 115 title "op=r,batch_size=128" with linespoints, \
    'storage-performance-data.txt' index 116 title "op=r,batch_size=256" with linespoints, \
    'storage-performance-data.txt' index 117 title "op=r,batch_size=512" with linespoints, \
    'storage-performance-data.txt' index 118 title "op=r,batch_size=1024" with linespoints, \
    'storage-performance-data.txt' index 119 title "op=r,batch_size=2048" with linespoints, \
    'storage-performance-data.txt' index 120 title "op=r,batch_size=4096" with linespoints, \
    'storage-performance-data.txt' index 121 title "op=r,batch_size=8192" with linespoints, \
    'storage-performance-data.txt' index 122 title "op=r,batch_size=16384" with linespoints, \
    'storage-performance-data.txt' index 123 title "op=r,batch_size=32768" with linespoints, \
    'storage-performance-data.txt' index 124 title "op=r,batch_size=65536" with linespoints, \
    'storage-performance-data.txt' index 125 title "op=r,batch_size=131072" with linespoints, \
    'storage-performance-data.txt' index 126 title "op=r,batch_size=262144" with linespoints, \
    'storage-performance-data.txt' index 127 title "op=r,batch_size=524288" with linespoints, \
    'storage-performance-data.txt' index 128 title "op=r,batch_size=1048576" with linespoints, \
    'storage-performance-data.txt' index 129 title "op=r,batch_size=2097152" with linespoints, \
    'storage-performance-data.txt' index 130 title "op=r,batch_size=4194304" with linespoints, \
    'storage-performance-data.txt' index 131 title "op=r,batch_size=8388608" with linespoints

set title 'Random Write: Batch Random Block Access Bandwidth - WD1000DHTZ Velociraptor 10000rpm 1TB (HDD-2012)'

## MULTIPLOT(op,batch_size)
## SELECT LOG(2, block_size) AS x,
## (read_bytes_per_sec + write_bytes_per_sec) / 1024 / 1024 AS y, MULTIPLOT
## FROM stats
## WHERE exp='random' AND op IN ('w') AND host='HDD-2012'
## ORDER BY MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 132 title "op=w,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 133 title "op=w,batch_size=2" with linespoints, \
    'storage-performance-data.txt' index 134 title "op=w,batch_size=4" with linespoints, \
    'storage-performance-data.txt' index 135 title "op=w,batch_size=8" with linespoints, \
    'storage-performance-data.txt' index 136 title "op=w,batch_size=16" with linespoints, \
    'storage-performance-data.txt' index 137 title "op=w,batch_size=32" with linespoints, \
    'storage-performance-data.txt' index 138 title "op=w,batch_size=64" with linespoints, \
    'storage-performance-data.txt' index 139 title "op=w,batch_size=128" with linespoints, \
    'storage-performance-data.txt' index 140 title "op=w,batch_size=256" with linespoints, \
    'storage-performance-data.txt' index 141 title "op=w,batch_size=512" with linespoints, \
    'storage-performance-data.txt' index 142 title "op=w,batch_size=1024" with linespoints, \
    'storage-performance-data.txt' index 143 title "op=w,batch_size=2048" with linespoints, \
    'storage-performance-data.txt' index 144 title "op=w,batch_size=4096" with linespoints, \
    'storage-performance-data.txt' index 145 title "op=w,batch_size=8192" with linespoints, \
    'storage-performance-data.txt' index 146 title "op=w,batch_size=16384" with linespoints, \
    'storage-performance-data.txt' index 147 title "op=w,batch_size=32768" with linespoints, \
    'storage-performance-data.txt' index 148 title "op=w,batch_size=65536" with linespoints, \
    'storage-performance-data.txt' index 149 title "op=w,batch_size=131072" with linespoints, \
    'storage-performance-data.txt' index 150 title "op=w,batch_size=262144" with linespoints, \
    'storage-performance-data.txt' index 151 title "op=w,batch_size=524288" with linespoints, \
    'storage-performance-data.txt' index 152 title "op=w,batch_size=1048576" with linespoints, \
    'storage-performance-data.txt' index 153 title "op=w,batch_size=2097152" with linespoints, \
    'storage-performance-data.txt' index 154 title "op=w,batch_size=4194304" with linespoints, \
    'storage-performance-data.txt' index 155 title "op=w,batch_size=8388608" with linespoints

set title 'Random Read: Batch Random Block Access Bandwidth - Samsung SSD 840 EVO 1TB (SSD-2013)'

## MULTIPLOT(op,batch_size)
## SELECT LOG(2, block_size) AS x,
## (read_bytes_per_sec + write_bytes_per_sec) / 1024 / 1024 AS y, MULTIPLOT
## FROM stats
## WHERE exp='random' AND op IN ('r') AND host='SSD-2013'
## ORDER BY MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 156 title "op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 157 title "op=r,batch_size=2" with linespoints, \
    'storage-performance-data.txt' index 158 title "op=r,batch_size=4" with linespoints, \
    'storage-performance-data.txt' index 159 title "op=r,batch_size=8" with linespoints, \
    'storage-performance-data.txt' index 160 title "op=r,batch_size=16" with linespoints, \
    'storage-performance-data.txt' index 161 title "op=r,batch_size=32" with linespoints, \
    'storage-performance-data.txt' index 162 title "op=r,batch_size=64" with linespoints, \
    'storage-performance-data.txt' index 163 title "op=r,batch_size=128" with linespoints, \
    'storage-performance-data.txt' index 164 title "op=r,batch_size=256" with linespoints, \
    'storage-performance-data.txt' index 165 title "op=r,batch_size=512" with linespoints, \
    'storage-performance-data.txt' index 166 title "op=r,batch_size=1024" with linespoints, \
    'storage-performance-data.txt' index 167 title "op=r,batch_size=2048" with linespoints, \
    'storage-performance-data.txt' index 168 title "op=r,batch_size=4096" with linespoints, \
    'storage-performance-data.txt' index 169 title "op=r,batch_size=8192" with linespoints, \
    'storage-performance-data.txt' index 170 title "op=r,batch_size=16384" with linespoints, \
    'storage-performance-data.txt' index 171 title "op=r,batch_size=32768" with linespoints, \
    'storage-performance-data.txt' index 172 title "op=r,batch_size=65536" with linespoints, \
    'storage-performance-data.txt' index 173 title "op=r,batch_size=131072" with linespoints, \
    'storage-performance-data.txt' index 174 title "op=r,batch_size=262144" with linespoints, \
    'storage-performance-data.txt' index 175 title "op=r,batch_size=524288" with linespoints, \
    'storage-performance-data.txt' index 176 title "op=r,batch_size=1048576" with linespoints, \
    'storage-performance-data.txt' index 177 title "op=r,batch_size=2097152" with linespoints, \
    'storage-performance-data.txt' index 178 title "op=r,batch_size=4194304" with linespoints, \
    'storage-performance-data.txt' index 179 title "op=r,batch_size=8388608" with linespoints

set title 'Random Write: Batch Random Block Access Bandwidth - Samsung SSD 840 EVO 1TB (SSD-2013)'

## MULTIPLOT(op,batch_size)
## SELECT LOG(2, block_size) AS x,
## (read_bytes_per_sec + write_bytes_per_sec) / 1024 / 1024 AS y, MULTIPLOT
## FROM stats
## WHERE exp='random' AND op IN ('w') AND host='SSD-2013'
## ORDER BY MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 180 title "op=w,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 181 title "op=w,batch_size=2" with linespoints, \
    'storage-performance-data.txt' index 182 title "op=w,batch_size=4" with linespoints, \
    'storage-performance-data.txt' index 183 title "op=w,batch_size=8" with linespoints, \
    'storage-performance-data.txt' index 184 title "op=w,batch_size=16" with linespoints, \
    'storage-performance-data.txt' index 185 title "op=w,batch_size=32" with linespoints, \
    'storage-performance-data.txt' index 186 title "op=w,batch_size=64" with linespoints, \
    'storage-performance-data.txt' index 187 title "op=w,batch_size=128" with linespoints, \
    'storage-performance-data.txt' index 188 title "op=w,batch_size=256" with linespoints, \
    'storage-performance-data.txt' index 189 title "op=w,batch_size=512" with linespoints, \
    'storage-performance-data.txt' index 190 title "op=w,batch_size=1024" with linespoints, \
    'storage-performance-data.txt' index 191 title "op=w,batch_size=2048" with linespoints, \
    'storage-performance-data.txt' index 192 title "op=w,batch_size=4096" with linespoints, \
    'storage-performance-data.txt' index 193 title "op=w,batch_size=8192" with linespoints, \
    'storage-performance-data.txt' index 194 title "op=w,batch_size=16384" with linespoints, \
    'storage-performance-data.txt' index 195 title "op=w,batch_size=32768" with linespoints, \
    'storage-performance-data.txt' index 196 title "op=w,batch_size=65536" with linespoints, \
    'storage-performance-data.txt' index 197 title "op=w,batch_size=131072" with linespoints, \
    'storage-performance-data.txt' index 198 title "op=w,batch_size=262144" with linespoints, \
    'storage-performance-data.txt' index 199 title "op=w,batch_size=524288" with linespoints, \
    'storage-performance-data.txt' index 200 title "op=w,batch_size=1048576" with linespoints, \
    'storage-performance-data.txt' index 201 title "op=w,batch_size=2097152" with linespoints, \
    'storage-performance-data.txt' index 202 title "op=w,batch_size=4194304" with linespoints, \
    'storage-performance-data.txt' index 203 title "op=w,batch_size=8388608" with linespoints

set title 'Random Read: Batch Random Block Access Bandwidth - Samsung 960 Pro NVMe 512GB (NVMe-2016)'

## MULTIPLOT(op,batch_size)
## SELECT LOG(2, block_size) AS x,
## (read_bytes_per_sec + write_bytes_per_sec) / 1024 / 1024 AS y, MULTIPLOT
## FROM stats
## WHERE exp='random' AND op IN ('r') AND host='NVMe-2016'
## ORDER BY MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 204 title "op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 205 title "op=r,batch_size=2" with linespoints, \
    'storage-performance-data.txt' index 206 title "op=r,batch_size=4" with linespoints, \
    'storage-performance-data.txt' index 207 title "op=r,batch_size=8" with linespoints, \
    'storage-performance-data.txt' index 208 title "op=r,batch_size=16" with linespoints, \
    'storage-performance-data.txt' index 209 title "op=r,batch_size=32" with linespoints, \
    'storage-performance-data.txt' index 210 title "op=r,batch_size=64" with linespoints, \
    'storage-performance-data.txt' index 211 title "op=r,batch_size=128" with linespoints, \
    'storage-performance-data.txt' index 212 title "op=r,batch_size=256" with linespoints, \
    'storage-performance-data.txt' index 213 title "op=r,batch_size=512" with linespoints, \
    'storage-performance-data.txt' index 214 title "op=r,batch_size=1024" with linespoints, \
    'storage-performance-data.txt' index 215 title "op=r,batch_size=2048" with linespoints, \
    'storage-performance-data.txt' index 216 title "op=r,batch_size=4096" with linespoints, \
    'storage-performance-data.txt' index 217 title "op=r,batch_size=8192" with linespoints, \
    'storage-performance-data.txt' index 218 title "op=r,batch_size=16384" with linespoints, \
    'storage-performance-data.txt' index 219 title "op=r,batch_size=32768" with linespoints, \
    'storage-performance-data.txt' index 220 title "op=r,batch_size=65536" with linespoints, \
    'storage-performance-data.txt' index 221 title "op=r,batch_size=131072" with linespoints, \
    'storage-performance-data.txt' index 222 title "op=r,batch_size=262144" with linespoints, \
    'storage-performance-data.txt' index 223 title "op=r,batch_size=524288" with linespoints, \
    'storage-performance-data.txt' index 224 title "op=r,batch_size=1048576" with linespoints, \
    'storage-performance-data.txt' index 225 title "op=r,batch_size=2097152" with linespoints, \
    'storage-performance-data.txt' index 226 title "op=r,batch_size=4194304" with linespoints, \
    'storage-performance-data.txt' index 227 title "op=r,batch_size=8388608" with linespoints

set title 'Random Write: Batch Random Block Access Bandwidth - Samsung 960 Pro NVMe 512GB (NVMe-2016)'

## MULTIPLOT(op,batch_size)
## SELECT LOG(2, block_size) AS x,
## (read_bytes_per_sec + write_bytes_per_sec) / 1024 / 1024 AS y, MULTIPLOT
## FROM stats
## WHERE exp='random' AND op IN ('w') AND host='NVMe-2016'
## ORDER BY MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 228 title "op=w,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 229 title "op=w,batch_size=2" with linespoints, \
    'storage-performance-data.txt' index 230 title "op=w,batch_size=4" with linespoints, \
    'storage-performance-data.txt' index 231 title "op=w,batch_size=8" with linespoints, \
    'storage-performance-data.txt' index 232 title "op=w,batch_size=16" with linespoints, \
    'storage-performance-data.txt' index 233 title "op=w,batch_size=32" with linespoints, \
    'storage-performance-data.txt' index 234 title "op=w,batch_size=64" with linespoints, \
    'storage-performance-data.txt' index 235 title "op=w,batch_size=128" with linespoints, \
    'storage-performance-data.txt' index 236 title "op=w,batch_size=256" with linespoints, \
    'storage-performance-data.txt' index 237 title "op=w,batch_size=512" with linespoints, \
    'storage-performance-data.txt' index 238 title "op=w,batch_size=1024" with linespoints, \
    'storage-performance-data.txt' index 239 title "op=w,batch_size=2048" with linespoints, \
    'storage-performance-data.txt' index 240 title "op=w,batch_size=4096" with linespoints, \
    'storage-performance-data.txt' index 241 title "op=w,batch_size=8192" with linespoints, \
    'storage-performance-data.txt' index 242 title "op=w,batch_size=16384" with linespoints, \
    'storage-performance-data.txt' index 243 title "op=w,batch_size=32768" with linespoints, \
    'storage-performance-data.txt' index 244 title "op=w,batch_size=65536" with linespoints, \
    'storage-performance-data.txt' index 245 title "op=w,batch_size=131072" with linespoints, \
    'storage-performance-data.txt' index 246 title "op=w,batch_size=262144" with linespoints, \
    'storage-performance-data.txt' index 247 title "op=w,batch_size=524288" with linespoints, \
    'storage-performance-data.txt' index 248 title "op=w,batch_size=1048576" with linespoints, \
    'storage-performance-data.txt' index 249 title "op=w,batch_size=2097152" with linespoints, \
    'storage-performance-data.txt' index 250 title "op=w,batch_size=4194304" with linespoints, \
    'storage-performance-data.txt' index 251 title "op=w,batch_size=8388608" with linespoints

################################################################################

set title 'Random: Batch Random Block Access Bandwidth - Batch Size 1 and 1024'

set key top left reverse Left font ",12"

set style line 1 lt 2 lc 1 dashtype 2
set style line 2 lt 2 lc 1 dashtype 1
set style line 3 lt 1 lc 1 dashtype 2
set style line 4 lt 1 lc 1 dashtype 1
set style line 5 lt 2 lc rgb "#00cc00" dashtype 2
set style line 6 lt 2 lc rgb "#00cc00" dashtype 1
set style line 7 lt 1 lc rgb "#00cc00" dashtype 2
set style line 8 lt 1 lc rgb "#00cc00" dashtype 1
set style line 9 lt 2 lc 3 dashtype 2
set style line 10 lt 2 lc 3 dashtype 1
set style line 11 lt 1 lc 3 dashtype 2
set style line 12 lt 1 lc 3 dashtype 1

## MULTIPLOT(host,op,batch_size)
## SELECT LOG(2, block_size) AS x,
## (read_bytes_per_sec + write_bytes_per_sec) / 1024 / 1024 AS y, MULTIPLOT
## FROM stats
## WHERE exp='random' AND op IN ('r','w') AND batch_size IN (1,1024)
## ORDER BY hostx,MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 252 title "host=HDD-2012,op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 253 title "host=HDD-2012,op=r,batch_size=1024" with linespoints, \
    'storage-performance-data.txt' index 254 title "host=HDD-2012,op=w,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 255 title "host=HDD-2012,op=w,batch_size=1024" with linespoints, \
    'storage-performance-data.txt' index 256 title "host=SSD-2013,op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 257 title "host=SSD-2013,op=r,batch_size=1024" with linespoints, \
    'storage-performance-data.txt' index 258 title "host=SSD-2013,op=w,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 259 title "host=SSD-2013,op=w,batch_size=1024" with linespoints, \
    'storage-performance-data.txt' index 260 title "host=NVMe-2016,op=r,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 261 title "host=NVMe-2016,op=r,batch_size=1024" with linespoints, \
    'storage-performance-data.txt' index 262 title "host=NVMe-2016,op=w,batch_size=1" with linespoints, \
    'storage-performance-data.txt' index 263 title "host=NVMe-2016,op=w,batch_size=1024" with linespoints

################################################################################

set title 'Sequential (Scan) and Random Block Bandwidth (Random) - Batch Size 1'

set style line 1 lt 2 lc 1 dashtype 2
set style line 2 lt 2 lc 1 dashtype 1
set style line 3 lt 1 lc 1 dashtype 2
set style line 4 lt 1 lc 1 dashtype 1
set style line 5 lt 2 lc rgb "#00cc00" dashtype 2
set style line 6 lt 2 lc rgb "#00cc00" dashtype 1
set style line 7 lt 1 lc rgb "#00cc00" dashtype 2
set style line 8 lt 1 lc rgb "#00cc00" dashtype 1
set style line 9 lt 2 lc 3 dashtype 2
set style line 10 lt 2 lc 3 dashtype 1
set style line 11 lt 1 lc 3 dashtype 2
set style line 12 lt 1 lc 3 dashtype 1

## MULTIPLOT(host,exp,op)
## SELECT LOG(2, block_size) AS x,
## COALESCE(total_size / time, read_bytes_per_sec + write_bytes_per_sec) / 1024 / 1024 AS y, MULTIPLOT
## FROM stats
## WHERE op IN ('r','w') AND batch_size IN (1)
## ORDER BY hostx,op,MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 264 title "host=HDD-2012,exp=random,op=r" with linespoints, \
    'storage-performance-data.txt' index 265 title "host=HDD-2012,exp=scan,op=r" with linespoints, \
    'storage-performance-data.txt' index 266 title "host=HDD-2012,exp=random,op=w" with linespoints, \
    'storage-performance-data.txt' index 267 title "host=HDD-2012,exp=scan,op=w" with linespoints, \
    'storage-performance-data.txt' index 268 title "host=SSD-2013,exp=random,op=r" with linespoints, \
    'storage-performance-data.txt' index 269 title "host=SSD-2013,exp=scan,op=r" with linespoints, \
    'storage-performance-data.txt' index 270 title "host=SSD-2013,exp=random,op=w" with linespoints, \
    'storage-performance-data.txt' index 271 title "host=SSD-2013,exp=scan,op=w" with linespoints, \
    'storage-performance-data.txt' index 272 title "host=NVMe-2016,exp=random,op=r" with linespoints, \
    'storage-performance-data.txt' index 273 title "host=NVMe-2016,exp=scan,op=r" with linespoints, \
    'storage-performance-data.txt' index 274 title "host=NVMe-2016,exp=random,op=w" with linespoints, \
    'storage-performance-data.txt' index 275 title "host=NVMe-2016,exp=scan,op=w" with linespoints

set title 'Sequential (Scan) and Random Block Bandwidth (Random) - Batch Size 128'

## MULTIPLOT(host,exp,op)
## SELECT LOG(2, block_size) AS x,
## COALESCE(total_size / time, read_bytes_per_sec + write_bytes_per_sec) / 1024 / 1024 AS y, MULTIPLOT
## FROM stats
## WHERE op IN ('r','w') AND batch_size IN (128)
## ORDER BY hostx,op,MULTIPLOT,x
plot \
    'storage-performance-data.txt' index 276 title "host=HDD-2012,exp=random,op=r" with linespoints, \
    'storage-performance-data.txt' index 277 title "host=HDD-2012,exp=scan,op=r" with linespoints, \
    'storage-performance-data.txt' index 278 title "host=HDD-2012,exp=random,op=w" with linespoints, \
    'storage-performance-data.txt' index 279 title "host=HDD-2012,exp=scan,op=w" with linespoints, \
    'storage-performance-data.txt' index 280 title "host=SSD-2013,exp=random,op=r" with linespoints, \
    'storage-performance-data.txt' index 281 title "host=SSD-2013,exp=scan,op=r" with linespoints, \
    'storage-performance-data.txt' index 282 title "host=SSD-2013,exp=random,op=w" with linespoints, \
    'storage-performance-data.txt' index 283 title "host=SSD-2013,exp=scan,op=w" with linespoints, \
    'storage-performance-data.txt' index 284 title "host=NVMe-2016,exp=random,op=r" with linespoints, \
    'storage-performance-data.txt' index 285 title "host=NVMe-2016,exp=scan,op=r" with linespoints, \
    'storage-performance-data.txt' index 286 title "host=NVMe-2016,exp=random,op=w" with linespoints, \
    'storage-performance-data.txt' index 287 title "host=NVMe-2016,exp=scan,op=w" with linespoints

################################################################################
